package CardGames.cards;

import junit.framework.*;
import org.netbeans.junit.*;
import java.util.*;

/**
 *
 * @author Administrator
 */
public class StandardCardTest extends NbTestCase
{
    
    public StandardCardTest(java.lang.String testName)
    {
        super(testName);
    }
    
    public static void main(java.lang.String[] args)
    {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite()
    {
        TestSuite suite = new NbTestSuite(StandardCardTest.class);
        
        return suite;
    }
    
    /** Test of toString method, of class cribbage.StandardCard. */
    public void testToString()
    {
        System.out.println("testToString");
        
        String astrCards[] = new String[] { "AD", "10C", "4H" };
        try
        {
            for (int iCard = astrCards.length-1; iCard>=0; --iCard)
            {
                assertEquals(astrCards[iCard], new StandardCard(astrCards[iCard]).toString());
            }
        } catch (StandardCard.InvalidCard e) {
            fail("Card should not be invalid.");
        }
    }
    
    /** Test of generateDeck method, of class cribbage.StandardCard. */
    public void testGenerateDeck()
    {
        System.out.println("testGenerateDeck");
        
        //Deck generate test.
        Vector deck = StandardCard.generateDeck();
        assertEquals(52, deck.size());
        for (int index=0; index<deck.size() - 1; ++index)
        {
            StandardCard card1 = (StandardCard)deck.get(index);
            StandardCard card2 = (StandardCard)deck.get(index+1);
            if (index % 13 != 12)
            {
                assertTrue(card1.compareTo(card2) == -1);
            }
            else
            {
                assertTrue(card1.compareTo(card2) == 1);
            }
        }
        Collections.shuffle(deck);
    }
  
    /** Ensure that an invalid card cannot be created without an exception. */
    public void testInvalidCard()
    {
        try
        {
            StandardCard card = new StandardCard("10h");  //Ok, even though lower-case.
            StandardCard card2 = new StandardCard("11H");
            fail("Cannot have an eleven of hearts.");
        } catch (StandardCard.InvalidCard e) { }
    }
}