package CardGames.cards;

import junit.framework.*;
import org.netbeans.junit.*;

/** Unit tests for <code>SuitedCard</code>. */
public class SuitedCardTest extends NbTestCase
{
    
    public SuitedCardTest(java.lang.String testName)
    {
        super(testName);
    }
    
    public static void main(java.lang.String[] args)
    {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite()
    {
        TestSuite suite = new NbTestSuite(SuitedCardTest.class);
        
        return suite;
    }
    
    /** Test of compareTo method, of class cribbage.StandardCard. */
    public void testCompareTo()
    {
        System.out.println("testCompareTo");
        
        SuitedCard card = new SuitedCard(3,3);
        SuitedCard card2 = new SuitedCard(3,3);
        SuitedCard card3 = new SuitedCard(9,3);
        SuitedCard card4 = new SuitedCard(1,3);
        
        assertTrue(card.compareTo(card2) == 0);
        assertTrue(card.compareTo(card3) == -1);
        assertTrue(card.compareTo(card4) == 1);
        assertTrue(card2.compareTo(card3) == -1);
        assertTrue(card2.compareTo(card4) == 1);
        assertTrue(card3.compareTo(card4) == 1);
    }
    
    /** Test of equals method, of class cribbage.SuitedCard. */
    public void testEquals()
    {
        System.out.println("testEquals");
        
        SuitedCard card = new SuitedCard(3,3);
        SuitedCard card2 = new SuitedCard(3,3);
        assertEquals("Two cards created with (3,3) should be equal.", card, card2);
    }
    
    /** Test of sameSuit method, of class cribbage.SuitedCard. */
    public void testSameSuit()
    {
        System.out.println("testSameSuit");
        
        SuitedCard heart = new SuitedCard(1,2);
        SuitedCard heart2 = new SuitedCard(-5,2);
        SuitedCard spade = new SuitedCard(11,1);
        assertTrue(heart.sameSuit(heart2));
        assertTrue(spade.sameSuit(heart2) == false);
    }
    
    /** Test of sameValue method, of class cribbage.SuitedCard. */
    public void testSameValue()
    {
        System.out.println("testSameValue");
        
        SuitedCard five = new SuitedCard(5,-2);
        SuitedCard twelve = new SuitedCard(12,2);
        SuitedCard five2 = new SuitedCard(5,4);
        assertTrue(five.sameValue(twelve) == false);
        assertTrue(five.sameValue(five2));
    }
    
    /** Test of toString method, of class cribbage.SuitedCard. */
    public void testToString()
    {
        System.out.println("testToString");

        assertEquals("10_4", new SuitedCard(10, 4).toString());
        assertEquals("15_-3", new SuitedCard(15, -3).toString());
        assertEquals("1_0", new SuitedCard(1, 0).toString());
    }
    
    // Add test methods here, they have to start with 'test' name.
    // for example:
    // public void testHello() {}
}