package CardGames.probability;

import java.util.*;
import junit.framework.*;
import org.netbeans.junit.*;

public class CombinationIteratorTest extends NbTestCase
{
    
    public CombinationIteratorTest(java.lang.String testName)
    {
        super(testName);
    }
    
    public static void main(java.lang.String[] args)
    {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite()
    {
        TestSuite suite = new NbTestSuite(CombinationIteratorTest.class);
        
        return suite;
    }
    
    /** Test of hasNextCombination and nextCombination methods of class
     * cards.probability.CombinationIterator. */
    public void testNextAndHasNextCombination()
    {
        final int[][] aaiCombinations = new int[][] {{0,1},{0,2},{0,3},{1,2},{1,3},{2,3}};
        CombinationIterator combIter = new CombinationIterator(4, 2);  //Should be 6 combinations here.
        for (int iComb=0; iComb<6; ++iComb)
        {
            assertTrue("There should be another combination.", combIter.hasNextCombination());
            int[] aiThisComb = combIter.nextCombination();
            for (int iSubIndex = 0; iSubIndex <= 1; ++iSubIndex)
            {
                assertEquals("Wrong combination returned.", aaiCombinations[iComb][iSubIndex], aiThisComb[iSubIndex]);
            }
        }
        final String strNoNextComb = "There should not be another combination.";
        assertTrue(strNoNextComb, combIter.hasNextCombination() == false);
        assertEquals(strNoNextComb, 0, combIter.nextCombination().length);
    }
    
    /** Test the <code>CombinationIterator</code> constructor. */
    public void testConstructor()
    {
        try {
            CombinationIterator combIter = new CombinationIterator(0, 0); //Invalid.
            fail("Cannot create a 0,0 combination iterator.");
        } catch (IllegalArgumentException e) {}
        try {
            CombinationIterator combIter = new CombinationIterator(3, 4); //Invalid.
            fail("Cannot create a combination iterator with a subset size greater than the set size.");
        } catch (IllegalArgumentException e) {}
        try {
            CombinationIterator combIter = new CombinationIterator(0, 2); //Invalid.
            fail("Cannot create a 0,2 combination iterator.");
        } catch (IllegalArgumentException e) {}
        try {
            CombinationIterator combIter = new CombinationIterator(2, 0); //Invalid.
            fail("Cannot create a 2,0 combination iterator.");
        } catch (IllegalArgumentException e) {}
        
        try {
            CombinationIterator combIter = new CombinationIterator(3, 2);
            combIter = new CombinationIterator(5, 1);
        } catch (IllegalArgumentException e) {
            fail("Should be able to create 3,2 and 5,1 combination iterators.");
        }
    }
}